<?php

/*
	Plugin Name: Diagnostic Tool
	Plugin URI: http://mywwwsupport.com/plugin
	Description: Find common Email, Network and DNS setup problems & provides altered file montioring
	Revision: $Revision$
	Author: IMRE Ltd
	Author URI: http://mywwwsupport.com
*/

class MWSFileCheckSum {

    private $counter = 0;
    private $sum;
    private $files;

    function __construct() {
        $this->counter = 0;
        $this->sum = '';
    }

    function listFolderFiles($dir) {
        $ffs = scandir($dir);

        foreach ($ffs as $ff) {

            if ($ff != '.' && $ff != '..') {
                if (!is_dir($dir . '/' . $ff)) {
                    $sum = md5_file($dir . '/' . $ff);
                   
                    $this->files[$dir . '/' . $ff] = $sum;
                    $this->counter++;
                    $this->sum.= $sum;
                } else {
                   
                }
                if (is_dir($dir . '/' . $ff)) {
                    $this->listFolderFiles($dir . '/' . $ff);
                }

             
            }
        }
    }

    public function getCounter() {
        return $this->counter;
    }

    public function getSum() {
        return $this->sum;
    }

    public function getFiles() {
        return $this->files;
    }

	public function getChanges($options) {

		$limit = (isset($options['limit'])) ? $options['limit'] : 10;
		$offset = (isset($options['offset'])) ? $options['limit'] : 0;
		$changeset = (isset($options['changeset'])) ? $options['changeset'] : null;

		$data=get_option('mws_filessum_opt');
		$returnVar = array();
		$changeset=0;

		if (!is_array($data))
			return array();

		foreach ($data as $row) {
			$returnVar[] = (object) array (
									'date' =>$row[0],
									'filecount' =>$row[1],
									'md5' =>$row[2],
									'filechanges' =>$row[3],
									'changeset' => $changeset
									);
			$changeset++;
		}

		return array_reverse($returnVar);
	}

	public function runCron() {

		$this->listFolderFiles(ABSPATH);
		$info = get_option('mws_filessum_opt');
		$infoOld = $info;

		$date = new DateTime();
		$lastFiles = get_option('mws_filessumlist_opt');

		if ($infoOld[0][2] != md5($this->getSum())) {
			$diff1 = array_diff_assoc($this->getFiles(), $lastFiles);
			$diff2 = array_diff_assoc($lastFiles, $this->getFiles());
			$diff = array_merge($diff1, $diff2);
		}

		// Altered or deleted?
		$diffFiltered=array();
		$currentFiles=$this->getFiles();
		foreach ($diff as $thisFile => $md5sum) {
			$diffFiltered[$thisFile]=array();
			if (isset($currentFiles[$thisFile])) {
				if (!isset($lastFiles[$thisFile])) {
					$diffFiltered[$thisFile]['change'] = 'ADDED';
					$diffFiltered[$thisFile]['md5current']=$currentFiles[$thisFile];
				} else {
					$diffFiltered[$thisFile]['change'] = 'ALTERED';
					$diffFiltered[$thisFile]['md5current']=$currentFiles[$thisFile];
					$diffFiltered[$thisFile]['md5previous']=$lastFiles[$thisFile];
				}
			} else {
				$diffFiltered[$thisFile]['change'] = 'DELETED';
			}
		}

		$info[] = array($date->format('Y-m-d H:i:s'), $this->getCounter(), md5($this->getSum()), $diffFiltered);

		update_option('mws_filessum_opt', $info);
		update_option('mws_filessumlist_opt', $this->getFiles());
	}
}
