<?php

/*
	Plugin Name: Diagnostic Tool
	Plugin URI: http://mywwwsupport.com/plugin
	Description: Find common Email, Network and DNS setup problems & provides altered file montioring
	Revision: $Revision$
	Author: IMRE Ltd
	Author URI: http://mywwwsupport.com
*/

if (!class_exists( 'WP_Http' ))
	include_once( ABSPATH . WPINC. '/class-http.php' );

class MWSOutboundConnection {

    public function __construct() {
		add_action('http_api_debug', array( $this,'DebugOutbound'), 10, 5);
    }

	public function getTransport() {
		$wpHttp = new WP_Http();
		return $wpHttp->_get_first_available_transport(array());
	}

	public function DebugOutbound($response, $type, $class, $args, $url) {
		global $gMWSSettingsVals;

		if ($gMWSSettingsVals->disable_http_filter == true) {
			error_log ('Disabled http debug hook');
			return;
		 } 


		$connections = get_option('mws_outconnplug_con');
		$date = new DateTime();
		$e = $response;
		//var_dump($e);
		if (is_wp_error($e)) {
			$error = $e->get_error_message();
		} else {
			$error = 'success';
		}

		$connections[] = array(var_export($url, true), $date->format('Y-m-d H:i:s'), $error);
		update_option('mws_outconnplug_con', $connections);
	}

    public function HTTPCheck() {
		header('Content-Type: application/json');
		$url = $_POST['url'];
		//$request = new WP_Http;
		$result = wp_remote_request($url, array ('timeout' => 20)); //$request->request($url);
		$resJSON=array();
		if (is_wp_error($result)) {
			$resJSON['result'] = false;
			$resJSON['message'] = $result->get_error_messages();
		} else { 
			$resJSON['result'] = true;
			$resJSON['message'] = 'Success';
		}

		echo json_encode($resJSON);
		die();
    }

    public function MailCheck() {
		header('Content-Type: application/json');
		$email = $_POST['email'];
		$testType = intval($_POST['type']);
		$server = (strtolower(substr(php_uname('s'), 0, 3)) === 'win') ? ini_get('SMTP') .':'. ini_get('smtp_port') : ini_get('sendmail_path');

		if (!preg_match('/^[12]$/', $testType)) {
			echo json_encode(array('result'=>false, 'message'=>'Type type invalid'));
			die();
		}

		if (!preg_match('/^[a-zA-Z0-9@\.\-\_]*$/', $email)) {
			echo json_encode(array('result'=>false, 'message'=>'Invalid Email Address'));
			die();
		}

		$subject='Mail Test';
		$body='www.mywwwsupport.com email test for your wordpress website. ';

		$res=array();
		$res['message'] = 'No debug available';
		if ($testType == 1) {
			$subject = $subject.' One - PHP builtin';
			$mailRes = mail($email, $subject, $body);
		} else {
			$subject = $subject.' Two - Wordpress function';
			$mailRes = wp_mail($email, $subject, $body);
		}

		if (!$mailRes) {
			$res['message'] = 'Server settings: '.$server;
		} else {
			$res['message'] = 'Success: Pleace check your inbox for &quot;'.$subject.'&quot;';
		}

		$res['result'] = $mailRes;

		echo json_encode($res);
		die();
    }
}
