<?php 

/*
	Plugin Name: Diagnostic Tool
	Plugin URI: http://mywwwsupport.com/plugin
	Description: Find common Email, Network and DNS setup problems & provides altered file montioring
	Revision: $Revision$
	Author: IMRE Ltd
	Author URI: http://mywwwsupport.com
*/

MWSOutboundConnectionsView::displayNotes();

class MWSOutboundConnectionsView {

    function __construct() {
    }

	static function displayNotes()
	{
		global $gMWSSettingsVals;

		$wpHttp = new MWSOutboundConnection();
		$transport = $wpHttp->getTransport();

		?>

		<div class="mwswrap">
		<?php mWSSubMenu(); ?>
		<div class="mwsmainpage">
		<h2>Outbound Connections</h2>

		<?php if ($gMWSSettingsVals->disable_http_filter == true) { echo '<p><strong><em>Outbound connections logging disabled. See <a href="'.MYWWWSUPPORTADMINPAGE.'views/mwssettings.php">settings</a></em></strong></p>'; } ?>

		<h3>About</h3>
		<p>When WordPress makes an outbound connection, this plugin records the call. The report below shows calls made, and a test can be made to see if the call is successful.</p>

		<h4>Live test</h4>
		<p>This test will make a HTTP request. If this test hangs or stops, you will need to contact your hosting provider and ask them to open outbound connections for port 80.</p>
		<p><em>Make sure the Test URL is valid</em></p>
		<form action="" id="mwshttptest">
			<div class="mws-test-line">
				<label>Transport:</label>
				<span><?php echo $transport; ?></span>
			</div>	
			<div class="mws-test-line">
				<label>Test URL:</label>
				<span><input type="text" id="mwshttptesturl" value="http://www.google.com" /></span>
			</div>	
			<div class="mws-test-line">
				<label>Result:</label>
				<span id="mwshttptesturlresult">Pending.....</span>
			</div>
			<div class="mws-test-line-button">
				<a href="#" id="mwshttptestsubmit" class="like-a-button">Run</a>
			</div>
		</form>

		<h4>Outbound Calls made by WordPress</h4>

		<p>Please note, this is a list of calls made by the HTTP_API class built into WordPress. Any plugin may use the cURL, fsocketopen(), PHP Streams or a number of other libraries which will NOT be recorded here. WordPress considers these &quot;transports&quot; and using these is not the prefered way of making outbound connections.</p> 

		<table class="wp-list-table widefat">
		<thead>
			<tr>
				<th>Date</th>
				<th>URL</th>
				<th>Result</th>
			</tr>
		</thead>
		<tbody>

		<?php


		// TODO: Back in?
		//echo '<form action="options.php" method="post">';
		//settings_fields('oc-group');
		//echo '<p class="submit"><input type="submit" class="button-primary" value="Clear" /></p>';
		//echo '</form>';

		$connections = get_option('mws_outconnplug_con');
		if (is_array($connections)) {
			$connections = array_reverse($connections);
			foreach ($connections as $c) {
				echo '<tr><td>' . $c[1] . '</td><td>' . $c[0] . '</td><td>' . $c[2] . '</td></tr>';
			}
		}

		?>

		</tbody>
		</table>

		<div style="clear:both"></div>
		</div>
		</div>

		<?php
	}

}
